program DelphUBB;

uses
  Windows,
  Messages,
  RichEdit,
  Parse in 'Parse.pas';

{$E exe}

{$R Images.res}

(*
  2001-03-17, CRA
    - Erste Version
  2001-03-17, NicoDE
    - Fenster-Klasse ohne globale Variablen
    - Gre nderbar
    - Minimalgre (berechnet)
    - Datei per Drop akzeptieren
    - Datei per Parameter laden
  2001-03-19, NicoDE
    - Delphi-Forum-Release
    - OwnerDraw Buttons :)
    - Version 1.0 verffentlicht
  2001-03-21, NicoDE
    - Button-Stil etwas gendert
    - neuer Button zum Lschen des Textfeldes
    - Version 1.1 verffentlicht
*)

{------------------------------------------------------------------------------}
{ ShellAPI.pas, kein uses, nicht fr das bisschen ;o) }

type
  HDROP = Longint;

const
  shell32 = 'shell32.dll';

procedure DragAcceptFiles(Wnd: HWND; Accept: BOOL); stdcall;
  external shell32 name 'DragAcceptFiles';
function DragQueryFile(Drop: HDROP; FileIndex: UINT; FileName: PChar; cb: UINT): UINT; stdcall;
  external shell32 name 'DragQueryFileA';
procedure DragFinish(Drop: HDROP); stdcall;
  external shell32 name 'DragFinish';

{------------------------------------------------------------------------------}

type
  PDlpUbbWndData = ^TDlpUbbWndData;
  TDlpUbbWndData = record
    LogoBM: HBITMAP;
    EmptyBM: HBITMAP;
    BtnEmpty: HWND;
    BtnFrmt: HWND;
    BtnInfo: HWND;
    BtnExit: HWND;
    BtnFont: HFONT;
    RichEdit: HWND;
    RichFont: HFONT;
  end;

const
  DLPUBB_NCMAINICON = MAKEINTRESOURCE(555);
  DLPUBB_IDB_DFLOGO = MAKEINTRESOURCE(1001);
  DLPUBB_IDB_EMPTYR = MAKEINTRESOURCE(1002);
  DLPUBB_BORDER = 5;
  DLPUBB_LOGO_HEIGHT = 110;
  DLPUBB_LOGO_WIDTH = 165;
  DLPUBB_LOGO_DOWN = 16;
  DLPUBB_EMPTY_HEIGHT = 20;
  DLPUBB_EMPTY_WIDTH = 17;
  DLPUBB_MENU_WIDTH = 120;
  DLPUBB_BTNHEIGHT = 25;

const
  DLPUBB_MAXDROPFILEBUFFER = $0000FFFE;

resourcestring
  DLPUBB_CAPTION = 'Delphi to UBB Formatter';
  DLPUBB_BTNFORMAT = 'Format Source'#13#10'(to clipboard)';
  DLPUBB_BTNINFO = 'Information ...';
  DLPUBB_BTNEXIT = 'Close Program';

resourcestring
  DLPUBB_VERSION = #13#10 +
    'Version 1.1 (2001-03-21)'#13#10 +
    '(special release for www.Delphi-Forum.de)'#13#10;
  DLPUBB_INFORMATION = #13#10 +
    'This programm was written to format delphi source code with UBB-tags'#13#10 +
    'to improve the appearance of code posted in UBB-forums.'#13#10 +
    'Our goal was to keep the program small but nevertheless comfortable.'#13#10 +
    'We hope it''ll help you save some work'#13#10#13#10 +
    'NicoDE & CRA'#13#10;

const
  DLPUBB_BACKBRUSH = $00DEDEDE;
  DLPUBB_EDITBKCLR = $00F7F7F7;
  DLPUBB_TXTSHADOW = $00909090;
  DLPUBB_BTXTCOLOR = $0000FFFF;

{------------------------------------------------------------------------------}

{ Utility-Funktion, erzeugt Child-Button }
function DlpUbbChildButton(Caption: PChar; Parent: HWND; Inst: HINST): HWND;
begin
  Result := CreateWindowEx(0, 'BUTTON', Caption, WS_CHILD or WS_VISIBLE or
    WS_TABSTOP or BS_MULTILINE or BS_OWNERDRAW, 0, 0, 1, 1, Parent, 0, Inst, nil);
end;

{ OnCreate der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnCreate(Wnd: HWND): LRESULT;
var
  WndData: PDlpUbbWndData;
  WndInst: HINST;
begin
  Result := LRESULT(-1);
  { Speicher fr die privaten Fenster-Daten anfordern }
  WndData := GetMemory(SizeOf(TDlpUbbWndData));
  if WndData <> nil then
  begin
    { Datenblock Fenster-Instanz zuweisen }
    SetWindowLong(Wnd, GWL_USERDATA, LongInt(WndData));
    { Caption setzen }
    SendMessage(Wnd, WM_SETTEXT, 0, LPARAM(PChar(DLPUBB_CAPTION)));
    { (Modul)Instanz-Handle der Fenster-Klasse holen }
    WndInst := GetWindowLong(Wnd, GWL_HINSTANCE);
    { Bilder aus den Ressourcen laden }
    WndData^.LogoBM := LoadBitmap(WndInst, DLPUBB_IDB_DFLOGO);
    WndData^.EmptyBM := LoadBitmap(WndInst, DLPUBB_IDB_EMPTYR);
    { Lschen-Button-Control als Child des Hauptfensters erzeugen }
    WndData^.BtnEmpty := DlpUbbChildButton(nil, Wnd, WndInst);
    { Format-Button-Control als Child des Hauptfensters erzeugen }
    WndData^.BtnFrmt := DlpUbbChildButton(PChar(DLPUBB_BTNFORMAT), Wnd, WndInst);
    { Info-Button-Control als Child des Hauptfensters erzeugen }
    WndData^.BtnInfo := DlpUbbChildButton(PChar(DLPUBB_BTNINFO), Wnd, WndInst);
    { Exit-Button-Control als Child des Hauptfensters erzeugen }
    WndData^.BtnExit := DlpUbbChildButton(PChar(DLPUBB_BTNEXIT), Wnd, WndInst);
    { Button-Font erzeugen }
    WndData^.BtnFont := CreateFont(-12, 0, 0, 0, FW_BOLD, 0, 0, 0, ANSI_CHARSET,
      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH,
      'MS Sans Serif');
    { Den Button-Controls den Font zuweisen }
    if (WndData^.BtnFrmt <> 0) and (WndData^.BtnFont <> 0) then
    begin
      SendMessage(WndData^.BtnFrmt, WM_SETFONT, WPARAM(WndData^.BtnFont),
        LPARAM(True));
      SendMessage(WndData^.BtnExit, WM_SETFONT, WPARAM(WndData^.BtnFont),
        LPARAM(True));
      SendMessage(WndData^.BtnInfo, WM_SETFONT, WPARAM(WndData^.BtnFont),
        LPARAM(True));
    end;
    { RichEdit-Control (Version 2/3) als Child des Hauptfensters erzeugen }
    WndData^.RichEdit := CreateWindowEx(0, 'RichEdit20A', nil,
      WS_CHILD or WS_VISIBLE or ES_MULTILINE or WS_HSCROLL or ES_AUTOHSCROLL or
      WS_VSCROLL or ES_AUTOVSCROLL, 0, 0, 1, 1, Wnd, 0, WndInst, nil);
    { Prfen, ob RichEdit-Control (Version 2/3) erzeugt wurde }
    if WndData^.RichEdit = 0 then
      { wenn nicht, dann RichEdit-Control (Version 1) erzeugen }
      WndData^.RichEdit := CreateWindowEx(0, 'RICHEDIT', nil,
        WS_CHILD or WS_VISIBLE or ES_MULTILINE or WS_HSCROLL or
        ES_AUTOHSCROLL or WS_VSCROLL or ES_AUTOVSCROLL, 0, 0, 1, 1,
        Wnd, 0, WndInst, nil);
    { RichEdit-Font erzeugen }
    WndData^.RichFont := CreateFont(-13, 0, 0, 0, FW_NORMAL, 0, 0, 0,
      ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
      FIXED_PITCH, 'Courier New');
    { Dem RichEdit-Control den Font zuweisen }
    if (WndData^.RichEdit <> 0) and (WndData^.RichFont <> 0) then
      SendMessage(WndData^.RichEdit, WM_SETFONT, WPARAM(WndData^.RichFont),
      LPARAM(True));
    { Ergebnis setzen }
    if (WndData^.BtnFrmt <> 0) and (WndData^.BtnExit <> 0) and
      (WndData^.BtnInfo <> 0) and (WndData^.BtnFont <> 0) and
      (WndData^.RichEdit <> 0) and (WndData^.RichFont <> 0) then
    begin
      Result := 0;
      { Hintergrundfarbe des RichEdit-Controls setzen }
      SendMessage(WndData^.RichEdit, EM_SETBKGNDCOLOR, 0, DLPUBB_EDITBKCLR);
      { Format-Button-Position setzen }
      MoveWindow(WndData^.BtnFrmt, DLPUBB_BORDER, DLPUBB_LOGO_HEIGHT,
        DLPUBB_MENU_WIDTH - 2 * DLPUBB_BORDER, 2 * DLPUBB_BTNHEIGHT, True);
      { Info-Button-Position setzen }
      MoveWindow(WndData^.BtnInfo, DLPUBB_BORDER,
        2 * DLPUBB_BTNHEIGHT + DLPUBB_LOGO_HEIGHT + DLPUBB_BORDER,
        DLPUBB_MENU_WIDTH - 2 * DLPUBB_BORDER, DLPUBB_BTNHEIGHT, True);
      { Exit-Button-Position setzen }
      MoveWindow(WndData^.BtnExit, DLPUBB_BORDER,
        3 * DLPUBB_BTNHEIGHT + 2 * DLPUBB_BORDER + DLPUBB_LOGO_HEIGHT,
        DLPUBB_MENU_WIDTH - 2 * DLPUBB_BORDER,
        DLPUBB_BTNHEIGHT, True);
      { Eingabe-Fokus setzen }
      SetFocus(WndData^.RichEdit);
    end;
  end;
end;

{ OnDestroy der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnDestroy(Wnd: HWND): LRESULT;
var
  WndData: PDlpUbbWndData;
begin
  Result := 0;
  { Objekte freigeben }
  WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
  if WndData <> nil then
  begin
    if WndData^.LogoBM <> 0 then
      DeleteObject(WndData^.LogoBM);
    if WndData^.EmptyBM <> 0 then
      DeleteObject(WndData^.EmptyBM);
    if WndData^.RichFont <> 0 then
      DeleteObject(WndData^.RichFont);
    if WndData^.BtnFont <> 0 then
      DeleteObject(WndData^.BtnFont);
    { Daten-Block freigeben, vorher vom Fenster "trennen" }
    SetWindowLong(Wnd, GWL_USERDATA, LongInt(nil));
    FreeMemory(WndData);
  end;
  { Besttigung fr's Beenden, lt WM_QUIT aus = Ende Nachrichten-Schleife }
  PostQuitMessage(0);
end;

{ OnSizing der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnSizing(Wnd: HWND): LRESULT;
var
  WndData: PDlpUbbWndData;
  Rect: TRect;
begin
  Result := LRESULT(-1);
  if GetClientRect(Wnd, Rect) then
  begin
    { Daten-Block des Fensters holen (fr Control-Handles) }
    WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
    if WndData <> nil then
    begin
      { RichEdit-Position setzen }
      MoveWindow(WndData^.RichEdit,
        DLPUBB_BORDER + DLPUBB_LOGO_WIDTH, 2 * DLPUBB_BORDER + DLPUBB_BTNHEIGHT,
        Rect.Right - Rect.Left - DLPUBB_LOGO_WIDTH - 2 * DLPUBB_BORDER,
        Rect.Bottom - Rect.Top - 3 * DLPUBB_BORDER - DLPUBB_BTNHEIGHT,
        True);
      { Lschen-Button-Position setzen }
      MoveWindow(WndData^.BtnEmpty,
        Rect.Right - Rect.Left - DLPUBB_BORDER - DLPUBB_BTNHEIGHT,
        Rect.Top + DLPUBB_BORDER, DLPUBB_BTNHEIGHT, DLPUBB_BTNHEIGHT,
        True);
      Result := 0;
    end;
  end;
end;

{ OnSize der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnSize(Wnd: HWND; SizeType: WPARAM): LRESULT;
begin
  Result := 0;
  if SizeType <> SIZE_MINIMIZED then
    Result := DlpUbbOnSizing(Wnd);
end;

{ OnPaint der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnPaint(Wnd: HWND): LRESULT;
var
  WndData: PDlpUbbWndData;
  PS: TPaintStruct;
  DC: HDC;
  Rect: TRect;
  MemDC: HDC;
  TmpBM: HBITMAP;
  OldBM: HBITMAP;
  LogoDC: HDC;
  OldLBM: HBITMAP;
  Loop: Integer;
begin
  Result := LRESULT(-1);
  DC := BeginPaint(Wnd, PS);
  if DC <> 0 then
  begin
    { Daten-Block des Fensters holen (fr Hintergrundbild-Handle) }
    WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
    if (WndData <> nil) and GetClientRect(Wnd, Rect) then
    begin
      { Temporren Gerte-Kontext fr Hintergrundbild erstellen }
      MemDC := CreateCompatibleDC(DC);
      { Temporres Bitmap-Objekt fr Hintergrundbild erstellen }
      TmpBM := CreateCompatibleBitmap(DC, Rect.Right - Rect.Left,
        Rect.Bottom - Rect.Top);
      { Bitmap in Kontext selektieren }
      OldBM := SelectObject(MemDC, TmpBM);
      { Mit dem Brush des Fensters fllen }
      FillRect(MemDC, Rect, GetClassLong(Wnd, GCL_HBRBACKGROUND));
      { Temporren Gerte-Kontext fr Logo-Bild erstellen }
      LogoDC := CreateCompatibleDC(DC);
      { Logo-Bitmap in Kontext selektieren }
      OldLBM := SelectObject(LogoDC, WndData^.LogoBM);
      { Logo in den temporren Hintergrund-Kontext kopieren }
      BitBlt(MemDC, 0, 0, DLPUBB_LOGO_WIDTH, DLPUBB_LOGO_HEIGHT,
        LogoDC, 0, 0, SRCCOPY);
      { Unteren Teil des Logos bis nach unten ziehen }
      Loop := DLPUBB_LOGO_HEIGHT;
      while Loop <= Rect.Bottom - Rect.Top do
      begin
        BitBlt(MemDC, 0, Loop, DLPUBB_LOGO_WIDTH, DLPUBB_LOGO_DOWN,
          LogoDC, 0, DLPUBB_LOGO_HEIGHT - DLPUBB_LOGO_DOWN, SRCCOPY);
        Inc(Loop, DLPUBB_LOGO_DOWN);
      end;
      { Nur die Update-Region kopieren - deswegen die ganze Arbeit :) }
      BitBlt(DC, PS.rcPaint.Left, PS.rcPaint.Top,
        PS.rcPaint.Right - PS.rcPaint.Left,
        PS.rcPaint.Bottom - PS.rcPaint.Top,
        MemDC, PS.rcPaint.Left, PS.rcPaint.Top, SRCCOPY);
      { Aufrumen }
      SelectObject(LogoDC, OldLBM);
      DeleteDC(LogoDC);
      SelectObject(MemDC, OldBM);
      DeleteObject(TmpBM);
      DeleteDC(MemDC);
      Result := 0;
    end;
  end;
  EndPaint(Wnd, PS);
end;

{ OnDrawItem der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnDrawItem(Wnd: HWND; Item: PDrawItemStruct): LRESULT;
var
  WndData: PDlpUbbWndData;
  MemDC: HDC;
  OldBM: HBITMAP;
  Text: array [0..1024] of Char;
  Rect: TRect;
begin
  Result := LRESULT(False);
  if Item <> nil then
  begin
    { Daten-Block des Fensters holen (fr Button/Bild-Handle) }
    WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
    if (WndData <> nil) and (Item^.hwndItem = WndData^.BtnEmpty) then
    begin
      { Rect sichern }
      Rect := Item^.rcItem;
      { mit Brush des Fensters fllen }
      FillRect(Item.hDC, Item.rcItem, GetClassLong(Wnd, GCL_HBRBACKGROUND));
      if (Item.itemState and ODS_SELECTED = ODS_SELECTED) then
        { Zeichen-Rahmen nach Unten-Rechts verschieben }
        { (erzeugt den "Druck-Effekt" fr das Bild) }
        OffsetRect(Item.rcItem, 2, 2);
      { Lschen-Bild zentriert zeichnen }
      MemDC := CreateCompatibleDC(Item^.hDC);
      OldBM := SelectObject(MemDC, WndData^.EmptyBM);
      SetBkColor(Item^.hDC, DLPUBB_BACKBRUSH);
      BitBlt(Item.hDC,
        (Item^.rcItem.Right - Item^.rcItem.Left - DLPUBB_EMPTY_WIDTH) shr 1
        + Item^.rcItem.Left,
        (Item^.rcItem.Bottom - Item^.rcItem.Top - DLPUBB_EMPTY_HEIGHT) shr 1
        + Item^.rcItem.Top,
        DLPUBB_EMPTY_WIDTH, DLPUBB_EMPTY_HEIGHT, MemDC, 0, 0, SRCCOPY);
      SelectObject(MemDC, OldBM);
      DeleteDC(MemDC);
    end
    else
    begin
      { mit Schwarz fllen }
      FillRect(Item^.hDC, Item^.rcItem, GetStockObject(BLACK_BRUSH));
      { Wenn Button gedrckt }
      if (Item^.itemState and ODS_SELECTED = ODS_SELECTED) then
        { Zeichen-Rahmen nach Unten-Rechts verschieben }
        { (erzeugt den "Druck-Effekt" fr die Schrift) }
        OffsetRect(Item^.rcItem, 2, 2);
      if (Item.itemState and ODS_FOCUS = ODS_FOCUS) then
      begin
        Rect := Item^.rcItem;
        InflateRect(Rect, -2, -2);
        OffsetRect(Rect, -1, -1);
        DrawFocusRect(Item^.hDC, Rect);
      end;
      { Text des Controls holen }
      SendMessage(Item^.hwndItem, WM_GETTEXT, SizeOf(Text), LPARAM(@Text[0]));
      { Gre des zu zeichnenden Rechtecks holen, da         }
      { vertikales Zentrieren "von Hand" erledigt werden mu }
      Rect := Item^.rcItem;
      DrawText(Item^.hDC, Text, lstrlen(Text), Rect, DT_CALCRECT or DT_WORDBREAK);
      { Zeichen-Rahmen nach Unten verschieben (vertikale Zentrierung) }
      Inc(Item^.rcItem.Top,
        ((Item^.rcItem.Bottom - Item^.rcItem.Top) - (Rect.Bottom - Rect.Top)) shr 1 - 2);
      { Zeichen-Modus transparent setzen }
      SetBkMode(Item^.hDC, TRANSPARENT);
      { Text-Schatten zeichen }
      SetTextColor(Item^.hDC, DLPUBB_TXTSHADOW);
      Inc(Item^.rcItem.Left, 2);
      Inc(Item^.rcItem.Top, 2);
      DrawText(Item^.hDC, Text, lstrlen(Text), Item^.rcItem, DT_CENTER or DT_WORDBREAK);
      { Text darber zeichen }
      SetTextColor(Item^.hDC, DLPUBB_BTXTCOLOR);
      Dec(Item^.rcItem.Left, 2);
      Dec(Item^.rcItem.Top, 2);
      DrawText(Item^.hDC, Text, lstrlen(Text), Item^.rcItem, DT_CENTER or DT_WORDBREAK);
      { fertig :) }
      Result := LRESULT(True);
    end;
  end;
end;

{ OnMinMaxInfo der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnMinMaxInfo(Wnd: HWND; Info: PMinMaxInfo): LRESULT;
var
  WndRect: TRect;
  Rect: TRect;
begin
  Result := LRESULT(-1);
  if GetWindowRect(Wnd, WndRect) and GetClientRect(Wnd, Rect) and
    (Info <> nil) then
  begin
    with Info^ do
    begin
      { Minimale Weite, 3 Rnder + LogoWeite + ButtonHhe}
      {                                   NonClientRandRandLinksRechts }
      ptMinTrackSize.x := 2 * DLPUBB_BORDER + DLPUBB_LOGO_WIDTH + DLPUBB_BTNHEIGHT +
        ((WndRect.Right - WndRect.Left) - (Rect.Right - Rect.Left));
      { Minimale Hhe, 3 Rnder + 4 ButtonHhe + LogoHhe }
      {                        + NonClientRandObenUnten }
      ptMinTrackSize.y := 3 * DLPUBB_BORDER + 4 * DLPUBB_BTNHEIGHT + DLPUBB_LOGO_HEIGHT +
        ((WndRect.Bottom - WndRect.Top) - (Rect.Bottom - Rect.Top));
      Result := 0;
    end;
  end;
end;

{ OnCommand der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnCommand(Wnd: HWND; Cmnd: WPARAM; Ctrl: HWND): LRESULT;
var
  WndData: PDlpUbbWndData;
  Laenge: LRESULT;
  Text: string;
  Info: TMsgBoxParams;
begin
  Result := LRESULT(-1);
  if HiWord(Cmnd) = BN_CLICKED then
  begin
    { Daten-Block des Fensters holen (fr Control-Handles) }
    WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
    if WndData <> nil then
    begin
      if Ctrl = WndData^.BtnEmpty then
      begin
        { RichEdit-Control leeren }
        Text := #0;
        SendMessage(WndData^.RichEdit, WM_SETTEXT, 0, LPARAM(@Text[1]));
      end
      else if Ctrl = WndData^.BtnFrmt then
      begin
        { Button wurde gedrckt }
        Text := '';
        { Lnge des Textes im RichEdit-Control ermitteln }
        Laenge := SendMessage(WndData^.RichEdit, WM_GETTEXTLENGTH, 0, 0) + 1;
        { Platz fr den Text schaffen }
        SetLength(Text, Laenge);
        { Text holen }
        SendMessage(WndData^.RichEdit, WM_GETTEXT, Laenge + 1, LPARAM(@Text[1]));
        { Und (in Zwischenablage) formatieren }
        Text := Formatiere(Text);
        Result := 0;
      end
      else if Ctrl = WndData^.BtnInfo then
      begin
        { Information wurde gewhlt }
        FillChar(Info, SizeOf(TMsgBoxParams), 0);
        Info.cbSize := SizeOf(TMsgBoxParams);
        Info.hwndOwner := Wnd;
        Info.hInstance := GetWindowLong(Wnd, GWL_HINSTANCE);
        Info.lpszText :=  PChar(DLPUBB_CAPTION + DLPUBB_VERSION + DLPUBB_INFORMATION);
        Info.lpszCaption := PChar(DLPUBB_BTNINFO);
        Info.dwStyle := MB_USERICON;
        Info.lpszIcon := DLPUBB_NCMAINICON;
        MessageBoxIndirect(Info);
        Result := 0;
      end
      else if Ctrl = WndData^.BtnExit then
      begin
        { Beenden wurde gewhlt }
        SendMessage(Wnd, WM_CLOSE, 0, 0);
        Result := 0;
      end;
    end;
  end;
end;

{ Utility-Funktion, Kopiert den Inhalt einer Datei in das RichEdit-Control }
function SetRichEditTextByFileName(Wnd: HWND; FileName: PChar): Boolean;
var
  WndData: PDlpUbbWndData;
  FileHandle: HFILE;
  SizeLow: DWORD;
  SizeHigh: DWORD;
  Buffer: Pointer;
begin
  Result := False;
  { Daten-Block des Fensters holen (fr RichEdit-Handle) }
  WndData := PDlpUbbWndData(GetWindowLong(Wnd, GWL_USERDATA));
  if WndData <> nil then
  if WndData^.RichEdit <> 0 then
  begin
    { Datei zum Lesen ffnen }
    FileHandle := CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ or
      FILE_SHARE_WRITE, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if FileHandle <> INVALID_HANDLE_VALUE then
    begin
      { Dateigre berprfen - begrenzt auf DLPUBB_MAXDRAGFILESIZE }
      SizeHigh := 0;
      SizeLow := GetFileSize(FileHandle, @SizeHigh);
      if SizeHigh <> 0 then
        SizeLow := DLPUBB_MAXDROPFILEBUFFER;
      if SizeLow > DLPUBB_MAXDROPFILEBUFFER then
        SizeLow := DLPUBB_MAXDROPFILEBUFFER;
      { Puffer fr Daten }
      Buffer := GetMemory(SizeLow + 1);
      if Buffer <> nil then
      begin
        { Ende Null-terminieren }
        PChar(Buffer)[SizeLow] := #0;
        { Daten lesen }
        if ReadFile(FileHandle, Buffer^, SizeLow, SizeHigh, nil) then
          if SizeLow = SizeHigh then
          begin
            { Text an das RichEdit-Control senden }
            SendMessage(WndData^.RichEdit, WM_SETTEXT, 0, LPARAM(Buffer));
            { Caret an Position 0 setzen }
            SendMessage(WndData^.RichEdit, EM_SETSEL, 0, 0);
            { Und dorthin scrollen }
            SendMessage(WndData^.RichEdit, EM_SCROLLCARET, 0, 0);
          end;
        { Puffer freigeben }
        FreeMemory(Buffer);
      end;
      { Datei-Handle schlieen }
      CloseHandle(FileHandle);
    end;
  end;
end;

{ OnDropFiles der Fenster-Klasse "TDelphUBB" }
function DlpUbbOnDropFiles(Wnd: HWND; Drop: HDROP): LRESULT;
var
  NameLenth: UINT;
  FileName: PChar;
begin
  Result := LRESULT(-1);
  { Anzahl der Datein erfragen (nur eine wird akzeptiert) }
  if DragQueryFile(Drop, UINT(-1), nil, 0) = 1 then
  begin
    { Lnge des Dateinamens ermitteln }
    NameLenth := DragQueryFile(Drop, 0, nil, 0);
    { Speicher fr den Dateinamen }
    FileName := GetMemory(NameLenth + 1);
    if FileName <> nil then
    begin
      { Namen holen }
      if DragQueryFile(Drop, 0, FileName, NameLenth + 1) = NameLenth then
        { Datei-Inhalt in des RichEdit-Control einlesen }
        if SetRichEditTextByFileName(Wnd, FileName) then
          Result := 0;
      { Puffer fr Dateinamen freigeben }
      FreeMemory(FileName);
    end;
  end;
  { Drop-Handle freigeben }
  DragFinish(Drop);
end;

{------------------------------------------------------------------------------}

{ Fenster-Prozedur der Klasse "TDelphUBB" }
function DlpUbbWndProc(Wnd: HWND; Msg: UINT; WPara: WPARAM; LPara: LPARAM): LRESULT; stdcall;
begin
  case Msg of
    WM_CREATE:
      Result := DlpUbbOnCreate(Wnd);
    WM_DESTROY:
      Result := DlpUbbOnDestroy(Wnd);
    WM_SIZING:
      Result := DlpUbbOnSizing(Wnd);
    WM_SIZE:
      Result := DlpUbbOnSize(Wnd, WPara);
    WM_PAINT:
      Result := DlpUbbOnPaint(Wnd);
    WM_DRAWITEM:
      Result := DlpUbbOnDrawItem(Wnd, PDrawItemStruct(LPara));
    WM_GETMINMAXINFO:
      Result := DlpUbbOnMinMaxInfo(Wnd, PMinMaxInfo(LPara));
    WM_COMMAND:
      Result := DlpUbbOnCommand(Wnd, WPara, HWND(LPara));
    WM_DROPFILES:
      Result := DlpUbbOnDropFiles(Wnd, HDROP(WPara));
  else
    Result := DefWindowProc(Wnd, Msg, WPara, LPara);
  end;
end;

{------------------------------------------------------------------------------}

var
  { Parameter fr die Fenster-Klasse }
  WC: TWndClassEx = (
    cbSize: SizeOf(TWndClassEx);
    style: 0; // CS_HREDRAW or CS_VREDRAW - ist zwar nett, aber flackert :)
    lpfnWndProc: @DlpUbbWndProc;
    cbClsExtra: 0;
    cbWndExtra: 0;
    hbrBackground: 0;
    lpszMenuName: nil;
    lpszClassName: 'TDelphUBB';
    hIconSm: 0;
  );

const
  BLB: TLogBrush =(
    lbStyle: BS_SOLID;
    lbColor: DLPUBB_BACKBRUSH;
    lbHatch: 0;
  );

var
  ScreenX: Integer;
  ScreenY: Integer;
  Cls:  ATOM;
  Wnd:  HWND;
  Msg:  TMsg;

begin
  { Bibliotheken fr RichEdit-Controls laden }
  if LoadLibrary('riched20.dll') = 0 then
    LoadLibrary('riched32.dll');
  { Parameter der Fenster-Klasse vervollstndigen }
  WC.hInstance := HInstance;
  WC.hIcon := LoadIcon(WC.hInstance, DLPUBB_NCMAINICON);
  WC.hCursor := LoadCursor(0, IDC_ARROW);
  WC.hbrBackground := CreateBrushIndirect(BLB);
  if WC.hbrBackground = 0 then
    WC.hbrBackground := COLOR_BTNFACE + 1;
  { Fenster-Klasse registrieren }
  Cls := RegisterClassEx(WC);
  if Cls <> 0 then
  begin
    ScreenX := GetSystemMetrics(SM_CXSCREEN);
    ScreenY := GetSystemMetrics(SM_CYSCREEN);
    { Instanz der Fenster-Klasse erzeugen }
    Wnd := CreateWindowEx(WS_EX_CLIENTEDGE, WC.lpszClassName, nil,
      WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,
      (ScreenX - 600) shr 1, (ScreenY - 400) shr 1, 600, 400, 0, 0,
      WC.hInstance, nil);
    if Wnd <> 0 then
    begin
      { Fenster fr DragDrop von Datein registrieren }
      DragAcceptFiles(Wnd, True);
      { Fenster anzeigen }
      ShowWindow(Wnd, SW_SHOW);
      { Fenster aktualisieren }
      UpdateWindow(Wnd);
      { Auf Kommandozeilenparamter prfen }
      if ParamCount >= 1 then
        SetRichEditTextByFileName(Wnd, PChar(ParamStr(1)));
      { Nachrichten-Schleife (Post) }
      while GetMessage(Msg, 0, 0, 0) do
      begin
        { Tastatur-Nachrichten umwandeln lassen }
        TranslateMessage(Msg);
        { Nachricht an die Fenster-Prozedur weitergeben }
        DispatchMessage(Msg);
      end;
      { Exit-Code aus dem Rckgabewert des Fensters bernehmen }
      ExitCode := Msg.wParam;
    end
    else
      ExitCode := GetLastError;
    { Klasse wieder deregistrieren - wir berlassen NICHTS WIndows :) }
    UnregisterClass(WC.lpszClassName, WC.hInstance);
  end
  else
    ExitCode := GetLastError;
  { Brush freigeben }
  if WC.hbrBackground <> COLOR_BTNFACE + 1 then
    DeleteObject(WC.hbrBackground);
end.

